﻿/// http://justinw.cnblogs.com
/// Mail:xiaoliang.justin@gmail.com
/// MSN:xiaoliang203@hotmail.com
using System;
using System.Data;
using System.Collections;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
namespace Justin.UILibrary
{
    /// <summary>
    /// FormLoadUtils 的摘要说明
    /// </summary>
    public class FormLoadUtils
    {
        public FormLoadUtils()
        {
            //
            // TODO: 在此处添加构造函数逻辑
            //
        }

        /// <summary>
        /// 动态加载用户自定义控件
        /// 
        /// 注释：噢！好臭！这可真是一个有很多参数需要初始化的方法啊！
        /// 解释：这里做了两件事情，1.初始化用户自定义控件；2.动态将用户控价加载到特定的PlaceHolder控件上。
        /// 　　　关于这两件事，一定是可以放到两个方法中去实现的，而且，应该有更好的方法来实现，但是这里只是一个Demo，It's OK!
        /// </summary>
        /// <param name="pg">Page对象</param>
        /// <param name="ph">PlaceHolder控件</param>
        /// <param name="uiPath">用户自定义控件的路径</param>
        /// <param name="act">关联的操作方法</param>
        /// <param name="type">UI的状态</param>
        /// <param name="source">保存数据源Hashtable(比如下拉框里的数据)</param>
        /// <param name="data">UI的初始数据Hashtable</param>
        public static void LoadUI(Page pg, PlaceHolder ph, string uiPath, ActivityEventHandler act,
                       UIType type, Hashtable source, Hashtable data)
        {

            UI ui = (UI)pg.LoadControl(uiPath);

            ui.ActionEvent += new ActivityEventHandler(act);
            ui.Type = type;
            ui.IniSource = source;
            ui.IniData = data;

            ph.Controls.Add(ui);

            //地雷2
            System.Threading.Thread.Sleep(3000);
        }

        /// <summary>
        /// 转换字符串为枚举
        /// </summary>
        public static UIType TransitionType(string type)
        {
            if (type == null) return UIType.View;
            switch (type.ToUpper())
            {
                case "N":
                    return UIType.New;
                case "V":
                    return UIType.View;
                case "M":
                    return UIType.Modify;
                default:
                    return UIType.View;
            }
        }
    }
}