﻿/// http://justinw.cnblogs.com
/// Mail:xiaoliang.justin@gmail.com
/// MSN:xiaoliang203@hotmail.com
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace Justin.UILibrary
{
    /// <summary>
    /// 所有用户自定义控件的基类,有了它，制作提交表单的时候的主要工作就是摆控件了！哈哈！
    /// 
    /// 原理和代码都很简单，就不详细写注释了～
    /// </summary>
    public partial class UI : System.Web.UI.UserControl
    {
        public event ActivityEventHandler ActionEvent;

        private UIType type = UIType.View;
        private Hashtable iniSource;
        private Hashtable iniDate;

        #region get/set

        public UIType Type
        {
            get
            {
                return this.type;
            }
            set
            {
                this.type = value;
            }
        }

        public Hashtable IniSource
        {
            get
            {
                return this.iniSource;
            }
            set
            {
                this.iniSource = value;
            }
        }

        public Hashtable IniData
        {
            get
            {
                return this.iniDate;
            }
            set
            {
                this.iniDate = value;
            }
        }

        #endregion

        //public UI(UIType type, Hashtable source, Hashtable data)
        //    : base()
        //{
        //    this.Type = type;
        //    this.IniSource = source;
        //    this.IniData = data;
        //}

        protected virtual void Page_Load(object sender, EventArgs e)
        {
            //其实我很不喜欢这个实现方式，因为调用这个方法以前必须保证
            //type,iniSource,iniDate这些变量不为空，而保证这点，只有在
            //构造函数里来初始化它们才是正道。再改吧...
            
            this.InitPage();
        }

        #region Templale Method Pattern

        protected virtual void UITypeIsNew()
        {

        }

        protected virtual void UITypeIsView()
        {
            FormConvertUtils.InitUIControl(this, false);
        }

        protected virtual void UITypeIsModify()
        {

        }

        #endregion

        //这里通过委托的事件，调用在客户端实现的自定义方法。
        //鬼才知道使用这个公共类的家伙会干些什么，将数据保存到数据库、保存到
        //ＸＭＬ文件里、或者只是在界面上显示一下；天哪，我可管不了那么多，我
        //把数据(ht)和UI的状态(type)给他，他自己随便玩去吧。
        protected void ExecActionEvent()
        {
            Hashtable ht = new Hashtable();
            FormConvertUtils.UI2Data(this, ht);
            if (ActionEvent != null)
                this.ActionEvent(ht, this.Type);
        }
 　　   
        private void InitPage()
        {
            //地雷1
            System.Threading.Thread.Sleep(3000);

            if (IniSource != null)
                FormConvertUtils.InitDropDownList(this, this.IniSource);
            if (IniData != null)
                FormConvertUtils.Data2UI(this, this.IniData);
            this.InitControl(Type);
        }

        //其实这里算是应用了模板方法模式，UITypeIsNew()这几个方法是在SubClass里实现的。
        //而它们被调用的算法是预定义在SuperClass里的。
        private void InitControl(UIType type)
        {
            switch (type)
            {
                case UIType.New:
                    this.UITypeIsNew();
                    break;

                case UIType.View:
                    this.UITypeIsView();
                    break;

                case UIType.Modify:
                    this.UITypeIsModify();
                    break;
            }
        }
    }
}