﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Justin.UILibrary;

public partial class _Default : System.Web.UI.Page
{
    public string show = "<br>";

    protected void Page_Load(object sender, EventArgs e)
    {
        string path = "Controls/DemoUI.ascx";//可以从XML里配置，进而实现同态切换不同的表单界面

        UIType type = FormLoadUtils.TransitionType(Request.QueryString["type"]);
        Hashtable data = (type == UIType.New) ? null : this.InitData("temp"); //New的时候，不需要初始化UI数据

        FormLoadUtils.LoadUI(this, this.PlaceHolder1, path, this.DoAction, type, this.InitSource("temp"), data);
    }

    //这个方法是在用户自定义控件里点提交按纽后触发的，参数中已有收集好的数据和UI的状态，
    //这里可以任意决定去做什么，这也是在无法封装的地方，因为鬼才知道你要做什么？
    private void DoAction(Hashtable dataList, UIType type)
    {
        //这里暂时只把数据显示在界面下方，以供演示。

        string title = (type == UIType.New) ? "提交后的数据" : "修改后的数据";
        show = show + title + "<br>";
        foreach (object key in dataList.Keys)
        {
            show = show + key.ToString() + " - " + dataList[key].ToString() + "<br>";
        }
    }

    #region 模拟准备数据

    //准备下拉框数据源的数据
    private Hashtable InitSource(string prj)
    {
        Hashtable ht = new Hashtable();

        //还记得我们的约定吗？key值保存的就是控件ID(实体字段名)
        ht.Add("sex", new string[] { "boy", "gril" });
        ht.Add("country", new string[] { "China", "England", "France" });

        return ht;
    }
    
    //准备UI界面的数据
    private Hashtable InitData(string id)
    {
        //地雷3
        System.Threading.Thread.Sleep(3000);
        Hashtable ht = new Hashtable();

        //还记得我们的约定吗？key值保存的就是控件ID(实体字段名)
        ht.Add("name", "Justin");
        ht.Add("sex", "boy");
        ht.Add("country", "China");
        ht.Add("remark", "He's a good boy!");

        return ht;
    }

    #endregion
}
